//genera un nmero aleatorio del 00 al 42 y lo muestra en la 
//matriz doble 7x10.
//El nmero aleatorio se genera a partir de una "semilla"  
//"seed". El "seed" depende de un contador interno de 0...255, 
//que se incrementa cada 2 milisegundos en el programa y se 
//guarda constantemente en la localidad 0x50. 
//Cuando el usuario oprime el botn de reset, el nmero "seed" se
//conserva en esa localidad, generando de esta forma un nmero
//aleatorio.Al encender por primera vez el sistema, el primer 
//nmero generado siempre es el 42, que es el resultado de 255/6 
//ya que la localidad 0x50 se inicializa con 0xFF.
//en la lnea "rana=seed/6", si se quiere cambiar el nmero aleatorio 
//mximo, modifique el 6. el nmero mximo es 255/x. 

#if defined(__PCM__)
#include "16f88adc.h" 
#include <stdlib.h>
#include <stdio.h>
#use delay (clock=4000000)
#use rs232 (baud=9600,xmit=PIN_B5,rcv=PIN_B2)
#rom 0X0000={0X018A,0X2803}         
#build(reset=0x0003)
int i,k,qu;
int seed;
int rana,zeta,mar;					//variable ndice malla principal 					//variable ndice para arreglo pf[]
#locate seed=0x50					//RESERVA LOCALIDAD PARA VARIABLE seed 
int jota=0;				//variable indice para arreglo pf[]
char matrix[]="00";		//string con texto
char pf[10]; 
#include "LETRASCCS2.h"
void main()
{
SPEN=0;        
CVRCON=0;
CMCON=7;
TRISA=0x00;    				//Configuramos puertos.
TRISB=0x00;
rana=seed/6;				//genera nmero aleatorio de 0...42
malla:
PORTB=0;
mar=atoi(matrix);	//*
if(mar==rana)goto sigue;
mar=mar+1;			//*
if(mar<10)
{matrix[1]++;goto sigue;}
if(mar==100)
{matrix[0]='0';matrix[1]='0';goto sigue;}
sprintf(matrix,"%d",mar);
sigue:	//*
jota=0;
for(k=0;k<2;k++)
{swatch(matrix[k]);}	//acomoda patrn de columnas
   for(zeta=0;zeta<4;zeta++)			//malla controla retraso entre nmeros
   {
   i=0;        	  //Inicializamos el contador auxiliar.
   PORTA=0x00;    //Inicializamos el Puerto A   
   RA1=1;                     //Reset al contador    
   RA1=0;                     //
   	  for(i=0;i<10;i++)    	  //El valor de la columna 0
   	  {                       //las 10 columnas
      PORTB=pf[i];             //Mostramos el valor de la columna
		for(qu=0;qu<200;qu++)
		{seed++;}				  //modifica nmero aleatorio
	  			  				//mantiene seal en PORTB durante 2 ms.
	  RA2=1;                  //Incrementa el contador            
      RA2=0; 
      PORTB=0X00;			  //evita que seal pase a siguiente columna                          
      }	
   }
goto malla;					
}


